
indexing
   author: "Miron Brezuleanu"
   purpose: "try something apparently impossible"
   
deferred class EE_EDGET
   
inherit
   EE_MAIN 
      rename
	 execute as ee_main_execute
	 command_execution as ee_command_execution
      end
   -- these renamings are a kludge
   
feature
   
   make(pname: STRING) is
	 -- basic initialization of the edget
      do
	 name := pname
	 !ARRAY[STRING]!output_edgets.make(1, 0)
	 message_pool := Void
	 widget := Void
      end
   
   put(content: ANY) is
	 -- the command to put a message in the output channel
      
	 -- if there is no output, a message is still issued with a 
	 -- void address (to be passed on from a potential master 
	 -- edget encapsulating this)
      
	 -- it also activates the idle calls that process the messages
      local 
	 i: INTEGER
	 message: EE_MESSAGE
      do
	 from
	    i := output_edgets.lower
	 until
	    i > output_edgets.upper
	 loop
	    !!message.make(name, output_edgets.item(i), content)
	    message_pool.messages.put(message)
	    i := i + 1
	 end
	 if output_edgets.empty then
	    !!message.make(name, Void, content)
	    message_pool.messages.put(message)
	 end	 
	 edget_manager.start_idling
      end
   
   run(message: ANY) is
	 -- processes a message passed as a parameter
      deferred
      end
   
   name: STRING
	 -- the name of the edget used in layout and other purposes
   
   widget: GTK_WIDGET
	 -- the widget associated with the edget (optional)      
   
feature { EE_MESSAGE_POOL }
   
   output_edgets: COLLECTION[STRING]
	 -- the name of the edgets at the end of the output channel 
	 -- of this edget
   
   message_pool: EE_MESSAGE_POOL
	 -- the message pool associated with this edget
   
   set_message_pool(nv: EE_MESSAGE_POOL) is
	 -- will be called by the `nv' object to include this edget
      do
	 message_pool := nv
      end
   
   add_output(output: EE_EDGET) is
	 -- will add an edget to the list of edgets to receive output 
	 -- from this one
      do
	 output_edgets.add_last(output.name)
      end
   
end
