
indexing
   author: "Miron Brezuleanu"
   purpose: "this is a container for edgets; given a design involving edgets,%
            % it can be hidden (incapsulated) in a master edget, with %
            %one input and one output (which really are the input and %
            %output of the hidden design)"
	    
class EE_MASTER_EDGET
   
inherit
   EE_EDGET
      -- this one is also an edget, it can be further encapsulated in
      -- larger masters (composition)
      rename
	 make as edget_make
      end
   EE_MESSAGE_POOL   
      -- this one is used to do the actual hiding
      rename
	 make as pool_make
	 run as pool_run
      redefine
	 add_edgets,
	 no_output
      end

creation
   make
   
feature
   
   make(pname: STRING) is
	 -- will build the object; add edgets inside with `add_edgets'
      do
	 edget_make(pname)
	 pool_make
      end
   
   add_edgets(edgets_list: COLLECTION[EE_EDGET]) is
	 -- in addition to `Precursor' this will also try and detect
	 -- the edget that is to receive the input of the master edget
	 -- (the edget that receives no input from the others in the
	 -- same message pool)
      local
	 i, j: INTEGER
	 d: DICTIONARY[INTEGER, STRING]
	 edget: EE_EDGET
      do
	 Precursor(edgets_list)
	 from
	    i := edgets.lower
	    !!d.make
	 until
	    i > edgets.upper
	 loop
	    edget := edgets.item(i)
	    from 
	       j := edget.output_edgets.lower
	    until
	       j > edget.output_edgets.upper
	    loop
	       d.put(0, edget.output_edgets.item(j))
	       j := j + 1
	    end
	    i := i + 1
	 end
	 from
	    i := edgets.lower
	 until
	    i > edgets.upper
	 loop
	    edget := edgets.item(i)
	    if not d.has(edget.name) then
	       master_input := edget.name
	       i := edgets.upper
	    end
	    i := i + 1
	 end
      end
   
   run(message: EE_MESSAGE) is
	 -- this one will pass on the message to the master input
      local
	 message2: EE_MESSAGE
      do
	 !!message2.make(Void, master_input, message.content)
	 messages.put(message2)
      end
   
   no_output(c: ANY) is
	 -- this one is the output of the "last" edget inside this
	 -- master and will be put in the output of the master edget
      do
	 put(c)
      end
   
feature {NONE}
   
   master_input: STRING
	 -- these are the names of the widgets that will
   
end
