
indexing
   author: "Miron Brezuleanu"
   purpose: "a manager for the messages of a set of linked fudgets"
   
class EE_MESSAGE_POOL
   
inherit
   EE_MAIN
   
creation
   make
   
feature
   
   make is
	 -- this will build the message pool and will register it to
	 -- the `edget_manager' object
      do
	 edget_manager.register(Current)
	 !!edgets.make
	 !!messages.make
      end
   
   add_edgets(edgets_list: COLLECTION[EE_EDGET]) is
	 -- will add the edgets to the message pool, also connecting
	 -- the output of each element to the next element (from right
	 -- to left, of course, in the good Fudgets' tradition)
      local
	 i: INTEGER
      do
	 from
	    i := edgets_list.upper - 1
	    edgets.put(edgets_list.item(edgets_list.upper), 
		       edgets_list.item(edgets_list.upper).name)
	    edgets_list.item(edgets_list.upper).set_message_pool(Current)
	 until
	    i < edgets_list.lower
	 loop
	    edgets.put(edgets_list.item(i),
		       edgets_list.item(i).name)		       
	    edgets_list.item(i+1).add_output(edgets_list.item(i))
	    edgets_list.item(i).set_message_pool(Current)
	    i := i - 1
	 end
      end
   
   run is
	 -- this will be called by `edget_manager' and will process 
	 -- some messages (if any)
      local
	 counter: INTEGER	 
	 message: EE_MESSAGE
      do
	 run_result := False
	 from
	    counter := 10 -- won't process more than 10 messages at a time!
	 until
	    messages.empty or counter = 0
	 loop
	    counter := counter - 1
	    if not messages.empty then
	       message := messages.get	       
	       if message.to_edget = Void then
		  no_output(message.content)
	       else
		  edgets.at(message.to_edget).run(message.content)
	       end
	       run_result := True
	    end
	 end
      end
   
   no_output(d: ANY) is
	 -- this command is used whenever there is no edget 
	 -- connected to some output channel; useful to implement hiding 
	 -- in master edgets
      do
      end      
	 
feature {EE_EDGET}
   
   edgets: DICTIONARY[EE_EDGET, STRING]
   messages: EXG_QUEUE[EE_MESSAGE]
   
feature {EE_MAIN}
   
   run_result: BOOLEAN
	 -- did `run' do anything?

end
   
