/* Modified by Michael de Hoog on 12/05/04:
Removed all of the C preprocessor pasting commands. */

#include <gdk/gdk.h>

/* button event stuff */

double ext_event_button_x(GdkEventButton *event) {
  return event->x;
}

double ext_event_button_y(GdkEventButton *event) {
  return event->y;
}

double ext_event_button_pressure(GdkEventButton *event) {
  return event->pressure;
}

double ext_event_button_xtilt(GdkEventButton *event) {
  return event->xtilt;
}

double ext_event_button_ytilt(GdkEventButton *event) {
  return event->ytilt;
}

double ext_event_button_x_root(GdkEventButton *event) {
  return event->x_root;
}

double ext_event_button_y_root(GdkEventButton *event) {
  return event->y_root;
}

int ext_event_button_time(GdkEventButton *event) {
  return event->time;
}

int ext_event_button_state(GdkEventButton *event) {
  return event->state;
}

int ext_event_button_button(GdkEventButton *event) {
  return event->button;
}

int ext_event_button_source(GdkEventButton *event) {
  return event->source;
}

int ext_event_button_deviceid(GdkEventButton *event) {
  return event->deviceid;
}

/* motion event stuff - just as the button, only is_hint added */

int ext_event_motion_is_hint(GdkEventMotion *event) {
  return event->is_hint;
}
     
/* key event stuff */

int ext_event_key_time(GdkEventKey *event) {
  return event->time;
}

int ext_event_key_state(GdkEventKey *event) {
  return event->state;
}

int ext_event_key_keyval(GdkEventKey *event) {
  return event->keyval;
}

int ext_event_key_length(GdkEventKey *event) {
  return event->length;
}

char * ext_event_key_string(GdkEventKey *event) {
  return event->string;
}
     
     /* crossing event stuff -- I don't know what this is, I don't need it, I don't wrap
	it for now !*/
     
     /* focus -- I assume `in' true means I get focus, false I lose focus */
     
int ext_event_focus_in(GdkEventFocus *event) {
  return event->in;
}

     /* expose event */
     /* because of stupid wrapping of coordinates inside area */

int ext_event_expose_x(GdkEventExpose *event) {
  return event->area.x;
}

int ext_event_expose_y(GdkEventExpose *event) {
  return event->area.y;
}

int ext_event_expose_width(GdkEventExpose *event) {
  return event->area.width;
}

int ext_event_expose_height(GdkEventExpose *event) {
  return event->area.height;
}

int ext_event_expose_count(GdkEventExpose *event) {
  return event->count;
}

     /* configure event */
     
int ext_event_configure_x(GdkEventConfigure *event) {
  return event->x;
}

int ext_event_configure_y(GdkEventConfigure *event) {
  return event->y;
}

int ext_event_configure_width(GdkEventConfigure *event) {
  return event->width;
}

int ext_event_configure_height(GdkEventConfigure *event) {
  return event->height;
}

	/* these are all the events I'm interested in for now; PJ and FP were interested only
	   in button_event -- so I guess the idea is: you need it, you do the wrapping */

