
#include <gdk_imlib.h>
#include <gdk/gdk.h>

int
ext_rgb_width(GdkImlibImage *im)
{
  return im->rgb_width;
}

int
ext_rgb_height(GdkImlibImage *im)
{
  return im->rgb_height;
}

void
ext_set_image_shape(GdkImlibImage *im, int r, int g, int b)
{
  GdkImlibColor color;
  color.r = r;
  color.g = g;
  color.b = b;
  gdk_imlib_set_image_shape(im, &color);
}

void
ext_get_image_shape(GdkImlibImage *im, int *r, int *g, int *b)
{
  GdkImlibColor color;
  gdk_imlib_get_image_shape(im, &color);
  *r = color.r;
  *g = color.g;
  *b = color.b;
}

void
ext_set_image_modifiers(GdkImlibImage *im,
		  double gamma,
		  double brightness,
		  double contrast)
{
  GdkImlibColorModifier mod;
  mod.gamma = gamma * 256;
  mod.brightness = brightness * 256;
  mod.contrast = contrast * 256;
  gdk_imlib_set_image_modifier(im, &mod);
}

void
ext_get_image_modifiers(GdkImlibImage *im,
		  double *gamma,
		  double *brightness,
		  double *contrast)
{
  GdkImlibColorModifier mod;
  gdk_imlib_get_image_modifier(im, &mod);
  *gamma = (double)mod.gamma / 256;
  *brightness = (double)mod.brightness / 256;
  *contrast = (double)mod.contrast / 256;
}

