
indexing
   author: "Miron Brezuleanu"
   purpose: "see GDK_ARRAYABLE; this class replaces GDK_OBJECT_ARRAY in GDK_%
   %DRAWABLE and is used in GDK_REGION; using it should be avoided, because %
   %it is very slow; optimizations are necessary"
   
class GDK_ARRAY

inherit
   GDK_ARRAYABLE

creation
   from_collection

feature

   from_collection(c: COLLECTION[GDK_ARRAYABLE]) is
		 -- creates a GDK_ARRAY to be used for drawing
		 -- this is very very slow
	  require
		 c.count /= 0
	  local
		 i, j, k, size: INTEGER
	  do
		 size := c.item(c.lower).storage.count * c.count
		 !!storage.make(size)
		 from
			i := 0
			j := 0
		 until
			j = size
		 loop
			from
			   k := 0 
			until 
			   k = c.item(c.lower + i).storage.count 
			loop
			   storage.put(c.item(c.lower + i).storage.item(k), j)
			   j := j + 1
			   k := k + 1
			end
			i := i + 1
		 end
	  end

   to_external: POINTER is
		 -- this is used to provide the pointer
	  do
		 Result := storage.to_external
	  end
   
end
