indexing
   description: "gdk colormap"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_colormap.e,v 1.4 1999/01/18 19:54:55 pcj Exp $"

class GDK_COLORMAP
inherit 
   GDK_OBJECT
   EXG_CONSTANTS
creation 
   exg_create,
   make,
   make_from_system

feature
   
   make is
	 -- creation of a new colormap
      do
	 gdkobject := ext_colormap_new(system_visual.to_external, 256)
      end
   
   make_from_system is
	 -- gets the system colormap (which happens to be the 
	 -- application's colormap
      do
	 gdkobject := ext_colormap_get_system
      end
   
   destroy is
	 -- getting rid of a colormap
      do
	 ext_colormap_unref(gdkobject)
      end

feature {NONE} -- links to gdk

   ext_colormap_new(p: POINTER; i: INTEGER): POINTER is
      external "C"
      alias "gdk_colormap_new"
      end

   ext_colormap_unref(p: POINTER) is
      external "C"
      alias "gdk_colormap_unref"
      end

   ext_colormap_get_system: POINTER is
      external "C"
      alias "gdk_colormap_get_system"
      end

end 

