indexing
   description: "gdk cursor"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_cursor.e,v 1.7 1999/01/27 06:22:50 pcj Exp $"

class GDK_CURSOR
inherit 
   GDK_OBJECT
creation
   make,
   make_from_integer, 
   make_from_pixmap
feature -- Creation

   make(type : GDK_CURSOR_TYPE) is
      do
	 gdkobject := ext_cursor_new(type.value)
      end -- make

   make_from_integer(n : INTEGER) is
      -- Deprecated (used to be make)
      do
	 gdkobject := ext_cursor_new(n)
      end

   make_from_pixmap ( source : GDK_PIXMAP ; fg, bg : GDK_COLOR ; 
		      x, y : INTEGER ) is
      do
	 gdkobject := ext_cursor_new_from_pixmap ( source.to_external, 
						   source.mask.to_external, 
						   fg.to_external,
						   bg.to_external, 
						   x, y ) 
      end

feature {ANY} -- Commands

   destroy is 
      do
	 ext_destroy(gdkobject)
      end

feature {NONE} -- Private

   ext_cursor_new (n : INTEGER) : POINTER is
      external "C"
      alias "gdk_cursor_new"
      end

   ext_cursor_new_from_pixmap ( source, mask, fg, bg : POINTER ; 
				x, y : INTEGER ) : POINTER is
      external "C"
      alias "gdk_cursor_new_from_pixmap"
      end

   ext_destroy (c_object : POINTER) is
      external "C"
      alias "gdk_cursor_destroy"
      end

   num_glyphs : INTEGER is
      local 
	 constants : GTK_CONSTANTS
      once
	 !!constants
	 Result := gdk_num_glyphs.value
      end
	 

invariant
end
