indexing
   description: "gdk event button"
   status: "You may be able to redistribute and/or modify this program.% 
   % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_event_button.e,v 1.5 1999/01/18 19:54:55 pcj Exp $"

		 -- slightly modified on 19990407 by Miron Brezuleanu
		 -- purpose: attribute no_clicks is 1 - click, 2 - double click
		 -- and 3 -- triple click

		 -- modified on 1999/05/20 by Miron Brezuleanu
		 -- about_button(no_button) tells if button no_button is 
		 -- involved in the event

class GDK_EVENT_BUTTON
inherit 
   GDK_EVENT   
      redefine exg_create
      end
creation
   make, exg_create
feature -- Creation
   make is
      do
      end -- make
   exg_create (p : POINTER) is
      do
		 gdkobject := p 
      end

feature {GDK_EVENT_FACTORY}
   
   set_no_clicks(pnc: INTEGER) is
		 -- sets the number of clicks (simple, double or triple)
      do
		 no_clicks := pnc
      end

feature {ANY} -- Queries

   no_clicks: INTEGER

   x : DOUBLE is
      do
		 Result := ext_event_button_x(gdkobject)
      end
   
   int_x: INTEGER is
	 -- an integer version of x (what we really want)
      do
	 Result := x.rounded
      end

   y : DOUBLE is
      do
		 Result := ext_event_button_y(gdkobject)
      end

   int_y: INTEGER is
	 -- an integer version of y (what we really want)
      do
	 Result := y.rounded
      end

   pressure : DOUBLE is
      do
		 Result := ext_event_button_pressure(gdkobject)
      end

   xtilt : DOUBLE is
      do
		 Result := ext_event_button_xtilt(gdkobject)
      end

   ytilt : DOUBLE is
      do
		 Result := ext_event_button_ytilt(gdkobject)
      end

   x_root : DOUBLE is
      do
		 Result := ext_event_button_x_root(gdkobject)
      end

   y_root : DOUBLE is
      do
		 Result := ext_event_button_y_root(gdkobject)
      end

   time : INTEGER is
      do
		 Result := ext_event_button_time(gdkobject) 
      end

   state : INTEGER is
      do
		 Result := ext_event_button_state(gdkobject) 
      end

   button : INTEGER is
      do
		 Result := ext_event_button_button(gdkobject) 
      end

   source : INTEGER is
      do
		 Result := ext_event_button_source(gdkobject)
      end

   deviceid : INTEGER is
      do
		 Result := ext_event_button_deviceid(gdkobject) 
      end

feature {NONE} -- Private

   ext_event_is_button_press(p : POINTER) : BOOLEAN is
      external "C"
      end

   ext_event_button_x (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_y (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_pressure (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_xtilt (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_ytilt (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_x_root (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_y_root (event : POINTER) : DOUBLE is
      external "C"
      end
   ext_event_button_time (event : POINTER) : INTEGER is
      external "C"
      end
   ext_event_button_state (event : POINTER) : INTEGER is
      external "C"
      end
   ext_event_button_button (event : POINTER) : INTEGER is
      external "C"
      end
   ext_event_button_source (event : POINTER) : INTEGER is
      external "C"
      end
   ext_event_button_deviceid (event : POINTER) : INTEGER is
      external "C"
      end

invariant
end
