indexing
   author: "Miron Brezuleanu"
   purpose: "Wrap data for the cracking of the expose event"

class GDK_EVENT_EXPOSE
   
inherit
   GDK_EVENT
      redefine
		 exg_create
      end

creation
   make, exg_create

feature -- Creation
   make is
      do
      end -- make
   exg_create (p : POINTER) is
      do
		 gdkobject := p 
      end
   
feature {ANY} -- Queries

   area: GDK_RECTANGLE is
		 -- returns the area which was exposed
      do
		 !!Result.make(ext_event_expose_x(gdkobject),
					   ext_event_expose_y(gdkobject),
					   ext_event_expose_width(gdkobject),
					   ext_event_expose_height(gdkobject))
      end

   count: INTEGER is
	  do
		 Result := ext_event_expose_count(gdkobject)
	  end

feature {NONE}
   
   ext_event_expose_x(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_expose_y(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_expose_width(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_expose_height(p: POINTER): INTEGER is
      external "C"
      end

   ext_event_expose_count(p: POINTER): INTEGER is
	  external "C"
	  alias "ext_event_expose_count"
	  end

end
