indexing
   description: "gdk event factory"
   status: "You may be able to redistribute and/or modify this program.% 
   % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_event_factory.e,v 1.4 1999/01/18 19:54:55 pcj Exp $"

		 -- slightly modified by Miron Brezuleanu to include 
		 -- button_event information about double/triple clicks (see 
		 -- gdk_event_button for more info (attribute no_clicks is 
		 -- the key addition) 
	 
		 -- modified again on 19990409 -- the export clause when inheriting
		 -- GTK_CONSTANTS doesn't work with se-0.78beta3

class GDK_EVENT_FACTORY
inherit 
   GTK_CONSTANTS
feature {ANY} -- Commands
   create_gdk_event ( p : POINTER ) : GDK_EVENT is 
      local 
		 type : INTEGER
		 be: GDK_EVENT_BUTTON
      do

		 if p = default_pointer then
			Result := Void
		 else
			-- Did I mention that inspections' being limited to 
			-- integer/character types is lame? 
			type := ext_gdk_event_type(p)
	    
			if gdk_button_press.equals_int ( type ) then
			   !!be.exg_create(p)
			   be.set_no_clicks(1)
			   Result := be
			elseif gdk_2button_press.equals_int ( type ) then
			   !!be.exg_create(p)
			   be.set_no_clicks(2)
			   Result := be
			elseif gdk_3button_press.equals_int ( type ) then
			   !!be.exg_create(p)
			   be.set_no_clicks(3)
			   Result := be
			elseif gdk_button_release.equals_int ( type ) then
			   !!be.exg_create(p)
			   be.set_no_clicks(0)
			   Result := be
			elseif gdk_motion_notify.equals_int(type) then
			   !GDK_EVENT_MOTION!Result.exg_create(p)
			elseif gdk_key_press.equals_int(type) or
			   gdk_key_release.equals_int(type) then
			   !GDK_EVENT_KEY!Result.exg_create(p)
			elseif gdk_focus_change.equals_int(type) then
			   !GDK_EVENT_FOCUS!Result.exg_create(p)
			elseif gdk_expose.equals_int(type) then
			   !GDK_EVENT_EXPOSE!Result.exg_create(p)		   
			elseif gdk_configure.equals_int(type) then
			   !GDK_EVENT_CONFIGURE!Result.exg_create(p)
			else
			   !!Result.exg_create(p)
			end
		 end
      end

   -- expose, motion_notify, key_press, focus_change, enter_notify, 
   -- configure, property_notify, selection_clear, proximity_in

feature {NONE}
   ext_gdk_event_type ( p : POINTER ) : INTEGER is
      external "C"
      end

invariant
end
