indexing
   description: "gdk font"
   status: "You may be able to redistribute and/or modify this program.% 
   % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_font.e,v 1.9 1999/01/18 19:54:55 pcj Exp $"

		 -- modified by Miron Brezuleanu, 1999/03/someday

class GDK_FONT
inherit 
   GDK_OBJECT
   GENERAL redefine is_equal end
creation
   make, 
   make_default, 
   font_load, 
   fontset_load,
   exg_create

feature -- Creation

   make, font_load ( font_name : STRING ) is
      do
		 gdkobject := ext_font_load(font_name.to_external)
      end -- make

   fontset_load ( fontset_name : STRING ) is
      do
		 gdkobject := ext_fontset_load ( fontset_name.to_external ) 
      end

feature {ANY}

   -- Please check. 
   ref is 
      do
		 ext_font_ref(gdkobject)
      end

   destroy is
      do 
		 unref
      end

   unref is
      do
		 ext_font_unref(gdkobject)
      end

   id : INTEGER is
      do
		 Result := ext_font_id ( gdkobject ) 
      end
   
   is_equal ( fontb : like Current ) : BOOLEAN is
      do
		 Result := ext_font_equal( gdkobject, fontb.to_external )
      end

   string_width ( string : STRING ) : INTEGER is
      do
		 Result := ext_string_width ( gdkobject, string.to_external )
      end

   text_width ( text : STRING ; text_length : INTEGER ) : INTEGER  is
      do
		 Result := ext_text_width ( gdkobject, text.to_external, text_length ) 
      end

   char_width ( character : CHARACTER ) : INTEGER is
      do
		 Result := ext_char_width ( gdkobject, character ) 
      end

   string_measure ( string : STRING ) : INTEGER is
      do
		 Result := ext_string_measure ( gdkobject, string.to_external ) 
      end

   text_measure ( text : STRING ; text_length : INTEGER ) : INTEGER is
      do
		 Result := ext_text_measure ( gdkobject, text.to_external, 
									  text_length )
      end

   char_measure ( character : CHARACTER ) : INTEGER is
      do
		 Result := ext_char_measure ( gdkobject, character ) 
      end

   string_height ( string : STRING ) : INTEGER is
      do
		 Result := ext_string_height ( gdkobject, string.to_external ) 
      end

   text_height ( text : STRING ; text_length : INTEGER ) : INTEGER is
      do
		 Result := ext_text_height ( gdkobject, 
									 text.to_external, text_length ) 
      end

   char_height ( character : CHARACTER ) : INTEGER is
      do
		 Result := ext_char_height ( gdkobject, character ) 
      end
      
   -- the next two added by me, Miron

   string_extents(str: STRING) : GDK_FONT_EXTENTS is
		 -- retrieves size information
      do
		 ext_string_extents(gdkobject, str.to_external, $lb, $rb, $w, $a, $d)
		 !!Result.make(lb, rb, w, a, d)
      end

   text_extents(str: STRING; n: INTEGER) : GDK_FONT_EXTENTS is
		 -- retrieves size information
		 -- seems BROKEN! -- hopefully fixed.
      do
		 ext_text_extents(gdkobject, str.to_external, n, $lb, $rb, $w, $a, $d)
		 !!Result.make(lb, rb, w, a, d)
      end

feature {NONE} -- Private

   -- SmallEiffel appears to have a small bug regarding the $ operator
   -- this doesn't look awful, so I'll fix it quietly
   -- Miron
   lb, rb, w, a, d: INTEGER

   ext_font_load ( font_name : POINTER ) : POINTER is
      external "C"
      alias "gdk_font_load"
      end

   ext_fontset_load ( fontset_name : POINTER ) : POINTER is
      external "C"
      alias "gdk_fontset_load"
      end

   ext_font_ref ( font : POINTER ) is
      external "C"
      alias "gdk_font_ref"
      end

   ext_font_unref ( font : POINTER ) is
      external "C"
      alias "gdk_font_unref"
      end

   ext_font_id ( font : POINTER ) : INTEGER is
      external "C"
      alias "gdk_font_id"
      end

   ext_font_equal ( fonta, fontb : POINTER ) : BOOLEAN is
      external "C"
      alias "gdk_font_equal"
      end

   ext_string_width ( font , string : POINTER ) :INTEGER is
      external "C"
      alias "gdk_string_width"
      end

   ext_text_width ( font, text : POINTER ; text_length : INTEGER ): INTEGER is
      external "C"
      alias "gdk_text_width"
      end
   
   ext_char_width ( font : POINTER ; character : CHARACTER ) : INTEGER is
      external "C"
      alias "gdk_char_width"
      end

   ext_string_measure ( font, string : POINTER ) : INTEGER is
      external "C"
      alias "gdk_string_measure"
      end

   ext_text_measure ( font, text : POINTER ; 
					  text_length : INTEGER ) : INTEGER is
      external "C"
      alias "gdk_text_measure"
      end

   ext_char_measure ( font : POINTER ; character : CHARACTER ) : INTEGER is
      external "C"
      alias "gdk_char_measure"
      end

   ext_string_height ( font, string : POINTER ) : INTEGER is
      external "C"
      alias "gdk_string_height"
      end

   ext_text_height ( font, text : POINTER ; 
					 text_length : INTEGER ) : INTEGER is
      external "C"
      alias "gdk_text_height"
      end

   ext_char_height ( font : POINTER ; character : CHARACTER ) : INTEGER is
      external "C"
      alias "gdk_char_height"
      end
   
   ext_string_extents(font, str, lb_, rb_, w_, a_, d_: POINTER) is
      external "C"
      alias "gdk_string_extents"
      end

   ext_text_extents(font: POINTER; str: POINTER; n: INTEGER; 
					lb_, rb_, w_, a_, d_: POINTER) is
      external "C"
      alias "gdk_text_extents"
      end

invariant
end 

