indexing
   description: "gdk pixmap"
   status: "You may be able to redistribute and/or modify this program.% 
   % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_pixmap.e,v 1.7 1999/01/18 19:54:55 pcj Exp $"

	 -- This should be a lot smarter.  We want to avoid doing any more 
	 -- pixmap_creates than is absolutely necessary. 
   
   
	 -- modified by Miron Brezuleanu 99/03/17
	 -- added a pixmap maker for off-screen drawing

class GDK_PIXMAP
inherit 
   GTK_MAIN
   EXG_CONSTANTS
   GDK_OBJECT
      rename 
	 exg_create as gdk_object_create
      redefine
	 make_default
      end
   GDK_DRAWABLE_WRAPPER

creation
   make_default, 
   make_from_xpm, 
   make_from_xpm_2, 
   make_from_xpm_d,
   create_pixmap,
   make
   
feature -- Creation
   
   make(w, h: INTEGER) is
      require
	 main_window.realized
	 main_window.window.to_external /= default_pointer
	 w > 0
	 h > 0
      do
	 gdkobject := ext_pixmap_new(main_window.window.to_external,
				     w, h, best_depth)
      ensure
	 gdkobject /= default_pointer
      end

   create_pixmap ( pixptr, maskptr : POINTER ) is
      require
	 pixptr /= default_pointer
	 maskptr /= default_pointer
      do
	 gdkobject := pixptr
	 !!mask.exg_create(maskptr)
      end

   make_from_xpm (window : GDK_WINDOW; transparent_color : GDK_COLOR; 
		  filename : STRING) is
      do
	 gdkobject := ext_pixmap_create_from_xpm(window.to_external, $maskobj, 
						 transparent_color.to_external, 
						 filename.to_external)
	 !!mask.exg_create(maskobj)
      ensure
	 gdkobject /= default_pointer
	 maskobj /= default_pointer
	 mask /= Void
      end -- make

   make_from_xpm_2 (filename : STRING) is
	 -- just like `make_from_xpm', but doesn't require a color 
	 -- also loads gzip and bzip2 compressed bitmaps
      local
	 transparent_color: GDK_COLOR
	 uses_compression: BOOLEAN
	 filename_2: STRING
      do
	 filename_2 := filename
	 if filename.has_suffix(".xpm.gz") then
	    system("cp " + filename + " xulescu.xpm.gz")
	    system("gunzip xulescu.xpm.gz")
	    filename_2 := clone("xulescu.xpm")
	    uses_compression := True
	 end
	    
	 if filename.has_suffix(".xpm.bz2") then
	    system("cp " + filename + " xulescu.xpm.bz2")
	    system("bunzip2 xulescu.xpm.bz2")
	    filename_2 := clone("xulescu.xpm")
	    uses_compression := True
	 end
	    
	 transparent_color := exg_black
	 gdkobject := ext_pixmap_create_from_xpm(main_window.window.to_external, 
						 $maskobj, 
						 transparent_color.to_external,
						 filename_2.to_external)
	 !!mask.exg_create(maskobj)
	 if uses_compression then
	    system("rm xulescu.xpm")
	 end
      ensure
	 gdkobject /= default_pointer
	 mask.to_external /= default_pointer
      end -- make

   make_from_xpm_d (window : GDK_WINDOW; transparent_color : GDK_COLOR; 
		    data : COLLECTION[STRING]) is
      local 
	 string_array : STRING_ARRAY
      do
	 !!string_array.from_collection(data)
	 gdkobject := 
	    ext_pixmap_create_from_xpm_d(window.to_external, $maskobj, 
					 transparent_color.to_external, 
					 string_array.to_external)
	 !!mask.exg_create(maskobj)
      ensure
	 gdkobject /= default_pointer
	 maskobj /= default_pointer
	 mask /= Void
      end

   make_default is
      do
	 gdkobject := default_pointer
	 !!mask.make_default
      end

feature {ANY} -- Queries

   mask : GDK_BITMAP

feature {NONE}

   internal_to_drawable: GDK_DRAWABLE is
	 -- for GDK_DRAWABLE_WRAPPER
      do
	 !!Result.exg_create(gdkobject)
      end

feature {ANY} -- Commands

   -- I think you have to do this explicitly. 
   destroy is 
      do
	 ext_pixmap_unref(gdkobject)
      end

feature {GTK_WIDGET}

   maskobj : POINTER

feature {NONE} -- Private

   ext_pixmap_create_from_xpm(c1, c2, c3, c4: POINTER) : POINTER is 
      external "C"
      alias "gdk_pixmap_create_from_xpm"
      end

   ext_pixmap_create_from_xpm_d(c1, c2, c3, c4: POINTER) : POINTER is 
      external "C"
      alias "gdk_pixmap_create_from_xpm_d"
      end

   ext_pixmap_unref(p: POINTER) is
      external "C"
      alias "gdk_pixmap_unref"
      end

   ext_pixmap_new(p: POINTER; w, h, d: INTEGER): POINTER is
      external "C"
      alias "gdk_pixmap_new"
      end

invariant
end

