indexing
   description: "gdk window"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_window.e,v 1.6 1999/01/18 19:54:55 pcj Exp $"

class GDK_WINDOW
inherit
   GDK_OBJECT
   GTK_MAIN
   GDK_DRAWABLE_WRAPPER   
creation
   make, exg_create, make_default
feature -- Creation
   make is
      do
      end -- make
feature {NONE} -- Queries
   
   internal_to_drawable: GDK_DRAWABLE is
	 -- to make use of GDK_DRAWABLE_WRAPPER
      do
	 !!Result.exg_create(gdkobject)
      end   

feature {ANY} -- Commands

   set_colormap_to_application_colormap is
	 -- sets the colormap for this window ...
      do
	 ext_window_set_colormap(gdkobject, 
				 application_colormap.to_external)
      end

   set_cursor(cursor : GDK_CURSOR) is
      do
	 ext_set_cursor(gdkobject, cursor.to_external)
      end

   set_icon(icon_window : GDK_WINDOW ;
	    pixmap : GDK_PIXMAP) is
      do
	 ext_window_set_icon ( gdkobject, icon_window.to_external, 
			       pixmap.to_external, pixmap.mask.to_external)
      end
   set_icon_name(name : STRING) is
      do
	 ext_window_set_icon_name(gdkobject, name.to_external) 
      end

   set_decorations(decorations : GDK_WMDECORATION) is
      do
	 ext_window_set_decorations (gdkobject, decorations.value)
      end

   set_functions ( functions : GDK_WMFUNCTION ) is
      do
	 ext_window_set_functions ( gdkobject, functions.value )
      end
   
feature { GTK_WINDOW } 
   -- these features should be available only to this class, the class
   -- that generates toplevel windows
   
   raise is
	 -- will raise the window above all others on the screen
      do
	 ext_window_raise(gdkobject)
      end
   
   lower is
	 -- will lower the window below all others on the screen
      do
	 ext_window_lower(gdkobject)
      end
   
feature {NONE} -- Private
   
   ext_window_raise(p: POINTER) is
      external "C"
      alias "gdk_window_raise"
      end
   
   ext_window_lower(p: POINTER) is
      external "C"
      alias "gdk_window_lower"
      end
   
   ext_set_cursor(c_object, cursor : POINTER) is
      external "C"
      alias "gdk_window_set_cursor"
      end
   ext_window_set_icon ( c_object, icon_window, pixmap, mask : POINTER ) is
      external "C"
      alias "gdk_window_set_icon"
      end
   ext_window_set_icon_name ( c_object, name : POINTER ) is
      external "C"
      alias "gdk_window_set_icon_name"
      end
   ext_window_set_decorations ( c_object : POINTER ; decorations : INTEGER ) is
      external "C"
      alias "gdk_window_set_decorations"
      end
   ext_window_set_functions ( c_object : POINTER ; functions : INTEGER ) is
      external "C"
      alias "gdk_window_set_functions"
      end
   ext_window_destroy(c_object: POINTER) is
      external "C"
      alias "gdk_window_destroy"
      end
     
   ext_window_set_colormap(p1, p2: POINTER) is
      external "C"
      alias "gdk_window_set_colormap"
      end

invariant
end
