indexing
   description: "gtk allocation"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_allocation.e,v 1.6 1999/01/18 19:54:56 pcj Exp $"

class GTK_ALLOCATION
   
inherit
   MEMORY

creation 
   exg_create, 
   make
   
feature -- Creation
   
   make(px, py, w, h: INTEGER) is
	 -- makes a `GTK_ALLOCATION' in GC space
      do
	 !!stupid_storage.make(ext_gtk_allocation_size)
	 gtkobject := stupid_storage.to_external
	 ext_gtk_allocation_fill(gtkobject, px, py, w, h)
      end

   exg_create ( p : POINTER ) is
      do
	 gtkobject := p 
      end

   to_external : POINTER is
      do
	 Result := gtkobject 
      end

feature {ANY} -- Queries
   
   x : INTEGER is
      do
	 Result := ext_allocation_x(gtkobject)
      end

   y : INTEGER is 
      do
	 Result := ext_allocation_x(gtkobject)
      end

   width : INTEGER is
      do
	 Result := ext_allocation_width(gtkobject)
      end

   height : INTEGER is
      do
	 Result := ext_allocation_height(gtkobject)
      end

feature {ANY} -- Commands
feature {NONE} -- Private
   ext_allocation_x (c_object : POINTER) : INTEGER is
      external "C"
      end

   ext_allocation_y (c_object : POINTER) : INTEGER is
      external "C"
      end

   ext_allocation_width (c_object : POINTER) : INTEGER is
      external "C"
      end

   ext_allocation_height (c_object : POINTER) : INTEGER is
      external "C"
      end
   
   ext_gtk_allocation_size: INTEGER is
      external "C"
      end
   
   ext_gtk_allocation_fill(p: POINTER; i1, i2, i3, i4: INTEGER) is
      external "C"
      end
   
   gtkobject : POINTER 
   
   stupid_storage: FIXED_ARRAY[CHARACTER]

invariant
end -- GTK_ALLOCATION

