indexing
   description: "gtk entry"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_entry.e,v 1.7 1999/01/26 06:30:31 pcj Exp $"

class GTK_ENTRY
inherit
   GTK_EDITABLE
      redefine 
	 set_editable, 
	 select_region, 
	 set_position
      end
   
creation
   make,
   make_with_max_length, 
   exg_create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_entry_new
      end -- make

   make_with_max_length ( max : INTEGER ) is 
      do
	 gtkobject := ext_entry_new_with_max_length ( max )
      end

feature {ANY} 

   set_text(ptext : STRING) is
      do	
	 ext_set_text(gtkobject, ptext.to_external)
      end -- set_text
   
   text, get_text : STRING is
      local 
	 p : POINTER 
      do
	 p := ext_get_text(gtkobject) 
	 if p /= default_pointer then
	    !!Result.from_external_copy(p)
	 end
      end -- get_text

   append_text(ptext : STRING) is
      do
	 ext_append_text(gtkobject, ptext.to_external) 
      end -- append_text

   prepend_text(ptext : STRING) is
      do
	 ext_prepend_text(gtkobject, ptext.to_external)
      end -- prepend_text

   select_region ( startpos, endpos : INTEGER ) is
      do
         ext_entry_select_region ( gtkobject, startpos, endpos )
      end

   set_position(pos : INTEGER) is
      do
	 ext_set_position(gtkobject, pos)
      end -- set_position

   set_editable(flag : BOOLEAN) is
      do
	 ext_set_editable(gtkobject, flag)
      end

   set_visibility ( visible_ : BOOLEAN ) is
      do
         ext_entry_set_visibility ( gtkobject, visible_ )
      end

   set_max_length ( max : INTEGER ) is
      require
	 -- isguint16(max) 
      do
	 ext_entry_set_max_length(gtkobject, max) 
      end

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
   ext_entry_new : POINTER is
      external "C"
      alias "gtk_entry_new"
      end -- ext_entry_new

   ext_entry_new_with_max_length ( max : INTEGER ) : POINTER is
      external "C"
      alias "gtk_entry_new_with_max_length"
      end

   ext_set_text(c_object : POINTER; ptext : POINTER) is
      external "C"
      alias "gtk_entry_set_text"
      end -- ext_set_text

   ext_get_text(c_object : POINTER) : POINTER is
      external "C"
      alias "gtk_entry_get_text"
      end -- ext_get_text

   ext_append_text(c_object : POINTER; ptext : POINTER) is
      external "C"
      alias "gtk_entry_append_text"
      end -- ext_append_text

   ext_prepend_text(c_object : POINTER; ptext : POINTER) is
      external "C"
      alias "gtk_entry_prepend_text"
      end -- ext_prepend_text

   ext_entry_select_region ( entry : POINTER ; startpos, endpos : INTEGER ) is
      external "C"
      alias "gtk_entry_select_region"
      end

   ext_set_position(c_object : POINTER; pos : INTEGER) is
      external "C"
      alias "gtk_entry_set_position"
      end -- ext_set_position

   ext_set_editable(c_object: POINTER; flag : BOOLEAN) is
      external "C"
      alias "gtk_entry_set_editable"
      end

   ext_entry_set_visibility ( entry : POINTER ; visible_ : BOOLEAN ) is
      external "C"
      alias "gtk_entry_set_visibility"
      end

   ext_entry_set_max_length ( entry : POINTER ; max : INTEGER ) is
      external "C"
      alias "gtk_entry_set_max_length"
      end

invariant
end -- GTK_ENTRY

