indexing
   description: "gtk text"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_text.e,v 1.8 1999/01/18 19:54:59 pcj Exp $"

class GTK_TEXT
inherit 
   GTK_EDITABLE
      redefine set_editable end
creation
   make,
   make_without_adjustments

feature -- Creation
   make ( hadj, vadj : GTK_ADJUSTMENT ) is 
      do
         gtkobject := ext_text_new ( hadj.to_external, vadj.to_external )
      end

   make_without_adjustments is
      do
	 gtkobject := ext_text_new( default_pointer, default_pointer )
      end

feature {ANY}

   deletion_status: INTEGER

   backward_delete ( nchars : INTEGER ) is
      do
         deletion_status := ext_text_backward_delete ( gtkobject, nchars )
      end

   forward_delete ( nchars : INTEGER ) is
      do
         deletion_status := ext_text_forward_delete ( gtkobject, nchars )
      end

   freeze  is
      do
         ext_text_freeze ( gtkobject )
      end

   length  : INTEGER is
      do
         Result := ext_text_get_length ( gtkobject )
      end

   point  : INTEGER is
      do
         Result := ext_text_get_point ( gtkobject )
      end

   set_font(pfont: GDK_FONT) is
	 -- sets the font for insert
      do
	 font := pfont
      end
   
   set_fore(pfore: GDK_COLOR) is
	 -- foreground color for insert
      do
	 fore := pfore
      end

   set_back(pback: GDK_COLOR) is
	 -- background color for insert
      do
	 back := pback
      end

   font: GDK_FONT
   fore, back: GDK_COLOR

   insert2 ( string : STRING ; tlength : INTEGER ) is
	 -- this is the new&improved call
      local
	 pfont, pfore, pback: POINTER
      do
	 if font = Void then
	    pfont := default_pointer
	 else
	    pfont := font.to_external
	 end
	 if fore = Void then
	    pfore := default_pointer
	 else
	    pfore := fore.to_external
	 end
	 if back = Void then
	    pback := default_pointer
	 else
	    pback := back.to_external
	 end
         ext_text_insert ( gtkobject, pfont, pfore, pback, 
			   string.to_external, tlength )
      end
   
   insert(pfont: GDK_FONT; pfore, pback: GDK_COLOR;
	  string: STRING; tlength: INTEGER) is
	 -- the old call
      do
         ext_text_insert ( gtkobject, pfont.to_external, 
			   pfore.to_external, pback.to_external, 
			   string.to_external, tlength)
      end

   set_adjustments ( hadj, vadj : GTK_ADJUSTMENT ) is
      do
         ext_text_set_adjustments ( gtkobject, hadj.to_external, 
				    vadj.to_external )
      end

   set_editable ( editable : BOOLEAN ) is
      do
         ext_text_set_editable ( gtkobject, editable )
      end

   set_point ( index : INTEGER ) is
      do
         ext_text_set_point ( gtkobject, index )
      end

   set_word_wrap ( word_wrap : INTEGER ) is
      do
	 ext_text_set_word_wrap ( gtkobject, word_wrap ) 
      end

   set_line_wrap ( line_wrap : INTEGER ) is
      do
	 ext_text_set_line_wrap ( gtkobject, line_wrap ) 
      end

   thaw  is
      do
         ext_text_thaw ( gtkobject )
      end

   text: STRING is
	 -- retrieves all of the text
      do
	 Result := chars(0, length)
      end   

feature {NONE} -- Private

   ext_text_backward_delete ( ptext : POINTER ; nchars : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_text_backward_delete"
      end

   ext_text_forward_delete ( ptext : POINTER ; nchars : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_text_forward_delete"
      end

   ext_text_freeze ( ptext : POINTER ) is
      external "C"
      alias "gtk_text_freeze"
      end

   ext_text_get_length ( ptext : POINTER ) : INTEGER is
      external "C"
      alias "gtk_text_get_length"
      end

   ext_text_get_point ( ptext : POINTER ) : INTEGER is
      external "C"
      alias "gtk_text_get_point"
      end

   ext_text_insert ( ptext, pfont, pfore, pback, pchars : POINTER ; 
		     plength : INTEGER ) is
      external "C"
      alias "gtk_text_insert"
      end

   ext_text_new ( hadj, vadj : POINTER ) : POINTER is
      external "C"
      alias "gtk_text_new"
      end

   ext_text_set_adjustments ( ptext, hadj, vadj : POINTER ) is
      external "C"
      alias "gtk_text_set_adjustments"
      end

   ext_text_set_editable ( ptext : POINTER ; editable : BOOLEAN ) is
      external "C"
      alias "gtk_text_set_editable"
      end

   ext_text_set_point ( ptext : POINTER ; index : INTEGER ) is
      external "C"
      alias "gtk_text_set_point"
      end

   ext_text_set_word_wrap ( ptext : POINTER ; word_wrap : INTEGER ) is
      external "C"
      alias "gtk_text_set_word_wrap"
      end

   ext_text_thaw ( ptext : POINTER ) is
      external "C"
      alias "gtk_text_thaw"
      end

   ext_text_set_line_wrap ( ptext : POINTER ; line_wrap : INTEGER ) is
      external "C"
      alias "gtk_text_set_line_wrap"
      end

invariant
end 

