
class POPUP_WINDOW

inherit
   GTK_MAIN
   GTK_COMMAND

creation
   make

feature

   make is
	 -- creates the window and the buttons inside it
      local
	 window: EXG_MAIN_WINDOW
	 -- the main window
	 
	 box: GTK_BOX
	 -- the layout
	 
	 button: GTK_BUTTON
	 -- used to create the buttons
      do
	 init
	 -- this one should be at the beginning of all Gtk+ programs
	 
	 !! window.make
	 -- creating the main window
	 
	 !GTK_HBOX! box.make (False, 0) 
	 -- creating the horizontal box used in the layout
	 
	 !! button.make_with_label ("Create popup")
	 button.signal_connect ("clicked", Current, "create popup")
	 box.pack_start (button, False, False, 0)
	 button.show
	 -- creating, configuring and showing the first button; when
	 -- creating the second button it is possible to use the same
	 -- variable, as the first button won't be garbage collected
	 -- as it has signals connected to it (see definition of
	 -- `signal_connect' in `GTK_OBJECT'), and the behaviour for 
	 -- the first button was also specified; actually the 
	 -- sequence for creating the second button is so similar one 
	 -- could write a command to create buttons and make two 
	 -- calls to it; Try it!
	 
	 !! button.make_with_label ("Quit")
	 button.signal_connect ("clicked", Current, "quit")
	 box.pack_start (button, False, False, 0)
	 button.show	 
	 -- very much like the first button, with only two diffs: the 
	 -- string it displays and the string it sends to `execute' 
	 -- when clicked
	 
	 -- notice how the use of a separate `GTK_COMMAND' was avoided
	 -- by inheriting from `GTK_COMMAND' and using `Current' as
	 -- the command object and of course defining `execute'
	 
	 window.add (box)
	 box.show
	 -- for the layout to appear, the hbox must be added to 
	 -- `window' and, of course, shown
	 
	 window.show
	 -- showing the main window
	 
	 main
	 -- bravely entering the main event loop
      end
   
   execute (d: ANY) is
	 -- will create the popups on demand
      local
	 s: STRING
	 apw: ACTUAL_POPUP_WINDOW
      do
	 s ?= d
	 if (equal (s, "create popup")) then
	    !! apw.make
	 elseif (equal (s, "quit")) then
	    quit
	 end
	 -- this was the "deciphering" of the message and the action 
	 -- triggered by the right message
      end

end

