
indexing
   purpose: "modelates a selection object"
   
class RUBBER_BAND_SELECTION
   
inherit
   SINGLETON_MAKER
   GTK_CONSTANTS
   EXG_CONSTANTS
   
creation
   make
   
feature
   
   make (r: GDK_RECTANGLE) is
	 -- builds the selection object from the given rectangle
      local
	 p: GDK_POINT
      do
	 !ARRAY[GDK_POINT]! points.make (1, 0)
	 !! p.make (r.x, r.y + r.height - 1)
	 points.add_last (p)
	 !! p.make (r.x, r.y)
	 points.add_last (p)
	 !! p.make (r.x + r.width - 1, r.y)
	 points.add_last (p)
	 !! p.make (r.x + r.width - 1,
		    r.y + r.height - 1)
	 points.add_last (p)
      end
   
   draw (d: GDK_DRAWABLE_WRAPPER) is
	 -- draws the visual representation of the selection on the
	 -- given drawable
      local
	 gc: GDK_GC
	 i : INTEGER
	 cp, cp2: GDK_POINT
      do
	 !! gc.make (d)
	 gc.set_foreground (exg_white)
	 gc.set_function (gdk_xor)
	 from i := 1 until i > points.upper loop
	    cp := points.item (i)
	    d.draw_rectangle (gc, False,
			      cp.x - Point_square_size,
			      cp.y - Point_square_size,
			      Point_square_size * 2 + 1,
			      Point_square_size * 2 + 1)		      
	    i := i + 1
	 end
	 from i := 1 until i > points.upper-1 loop
	    cp := points.item (i)
	    cp2 := points.item (i + 1)
	    d.draw_line (gc, cp.x, cp.y, cp2.x, cp2.y)
	    i := i + 1
	 end
	 cp := points.item (4)
	 cp2 := points.item (1)
	 d.draw_line (gc, cp.x, cp.y, cp2.x, cp2.y)
	 gc.destroy
      end
   
feature -- queries & attributes
   
   matches_point (p: GDK_POINT): BOOLEAN is
	 -- checks if `p' is close to any of the `points' of the
	 -- selection'; if so, returns True and `matched_point' holds
	 -- the point that matched and `matched_point_index' its index
      local
	 i: INTEGER
      do
	 from i := 1 until i > points.upper loop
	    if (p.x - points.item (i).x).abs < Point_square_size
	       and (p.y - points.item (i).y).abs < Point_square_size then
	       Result := True
	       matched_point := points.item (i)
	       matched_point_index := i
	       i := points.upper
	    end
	    i := i + 1
	 end
      end
	 
   matched_point: GDK_POINT
   matched_point_index: INTEGER
   
   points: COLLECTION[GDK_POINT]
   
end
	 
