
class PGEN

inherit
   GTK_MAIN
   EXG_FILE_TOOLS
   FILE_TOOLS

creation
   make

feature

   make is
      do
	 init
	 !!data
	 !!page_1.make(data)
	 !!page_2.make(data)
	 pages := << page_1, page_2 >>
	 !!window.make(pages) -- (A)
	 window.set_title("Project generator")
	 check_env 
	 -- thanks Ian! (the problem was that I was trying to use a
	 -- message box (which uses a pixmap) before creating the main
	 -- window - line (A), and the pixmap creation command
	 -- required the existance of a main window)
	 window.show
	 main
      end
   
   check_env is
	 -- this will check if the EXG shell variable is set correctly
      local
	 emb: EXG_MESSAGE_BOX	 
	 exg_path: STRING
	 systemx: SYSTEM
      do
	 exg_path := systemx.get_environment_variable("EXG")
	 if exg_path = Void or else exg_path.last = '/' then
	    !!emb.make
	    emb.set_message("EXG environment variable not set or %
			    %set incorectly!")
	    emb.run
	    die_with_code(exit_failure_code)
	 end
	 if not is_readable(exg_path + "/pb") then
	    !!emb.make
	    emb.set_message("Can't find %"pb%"!%N% 
					     %Maybe EXG is set incorrectly?")
	    emb.run
	    die_with_code(exit_failure_code)
	 end
      end

   window: WIZARD
   data: WIZARD_DATA
   pages: ARRAY[WIZARD_PAGE]
   page_1: PGEN_PAGE_1
   page_2: PGEN_PAGE_2
   
end
