
indexing
   author: "Miron Brezuleanu"
   purpose: "To draw an arrow on a given drawable"
   
class EXG_ARROW
   
creation
   make

feature -- Commands
   
   make(pd: GDK_DRAWABLE_WRAPPER) is
	 -- builds the arrow structure
      do
	 drawable := pd
	 head_distance := 1.0
	 head_wing := 0
      end
   
   set_head_distance (nv: DOUBLE) is
	 -- setter for `head_distance'
      do
	 head_distance := nv
      end

   set_head_wing (nv: INTEGER) is
	 -- setter for `head_wing'
      do
	 head_wing := nv
      end

   draw(x1, y1, x2, y2: INTEGER) is
	 -- draws the arrow
      local
	 t: EXG_TURTLE
	 gc: GDK_GC
	 dist, dist2: INTEGER
	 actual_head_wing: INTEGER
      do
	 !!gc.make(drawable)
	 drawable.draw_line (gc, x1, y1, x2, y2)
	 !!t.make (drawable, gc)
	 t.set_pos (x1, y1)
	 t.head_to (x2, y2)
	 dist := (x2-x1).abs * (x2-x1).abs
	    + (y2-y1).abs * (y2-y1).abs	 
	 dist2 := (dist.to_double.sqrt * head_distance).rounded
	 if head_wing = 0 then
	    actual_head_wing := (dist.to_double.sqrt * 0.063).rounded
	 else
	    actual_head_wing := head_wing
	 end
	 t.forward (dist2)
	 t.turn_left (150)
	 t.forward (actual_head_wing)
	 t.turn_left (120)
	 t.forward (actual_head_wing)
	 t.turn_left (120)
	 t.forward (actual_head_wing)
	 gc.destroy
      end

feature -- Queries
   
   drawable: GDK_DRAWABLE_WRAPPER
   
   head_distance: DOUBLE
	 -- varies from 0.0 to 1.0; tells where the head of the arrow 
	 -- should be drawn on the arrow. 0.0 means at the beginning 
	 -- of the arrow, 0.5 means in the middle, 1.0 at the end
   
   head_wing: INTEGER
	 -- the size of the "wing" of the head of the arrow (the
	 -- length of one side of the triangle drawn as the head of
	 -- the triangle); if set to 0 it will be calculated
	 -- automatically from the length of the arrow
   
end
   
